;This program is here to show how you can make a menu type system without having it highlighted. It uses
;the stor button font (the arrow) to point at the menu you choose. The program is very easy to add menu. 
;With this current setup it can only have a total of 8 menu spots. You can change that to many more by
;using the graph fonts (smaller). This only handels up and down for the buttons to. Enter chooses that item.
;I will show were to add things, or subtract, so you can have more or less menu items.
#include "ti86asm.inc"

.org _asm_exec_ram

 ld hl,Choice           ;this loads the Choice variable into hl
 ld (hl),$00            ;and this returns it to it's original value
;you could take this out, then the when you run this program it will have the arrow pointing at the last item
;you selected
ProgStart:
 call _clrScrn          ;clears the screen
 ld hl,$0000
 ld (_curRow),hl        ;puts the cursor at 0,0... or 1,1 if your use to BASIC
 ld hl,Menus            ;if you look at the bottom you will see what is being loaded into hl
 call _puts             ;this displays it.
 ld hl,(Choice)         ;loads the VALUE of choice into hl, the () are very important. they load the value choice
;instead of the location of choice into hl.
 ld (_curRow),hl        ;this tells the calculator were to put that arrow
 ld a,1Ch               ;stor button
 call _putc             ;displays the stor button
Keys:
 call _getky            ;this tells the calculator to start looking for keypresses.
 cp K_ENTER             ;this is a button..of course it's the enter button.
 jr z,Enter             ;now it subtracts the value that the calculator got from the button you pressed
;that button was subtracted from the equate of K_ENTER..K_ENTER isn't recognized by the calculator. The calculator
;see K_ENTER as 09h.....so if you hit enter 09h is in hl..i think..and it subtracts that from 09h since that is what
;K_ENTER equals. If it equals zero (z) then goto Enter.. that's what jr (jump) z(if zero),Enter(to the label Enter)
 cp K_DOWN
 jr z,Down
 cp K_UP
 jr z,Up
 jr nz,Keys             ;if the button you pressed did not equal any of those buttons then do it over again
Enter:                  
 ld a,4             ;If you want more or less menus you have to add or subtract to this number. If you want 1 more menu
 ;item then change the instruction to ld a,5  if you want one less menu item make it ld a,3
 ld hl,Choice       
 cp (hl)
 jr z,Menu5         ;then depending if you added more menu items you have to add to this list or subtract.
;now this is a nice way of doing things. If Choice==a then goto Menu5
 dec a      ;if not subtract a by one and check if Choice==a..if it is then goto Menu4 and so on till menu1
 cp (hl)
 jr z,Menu4
 dec a
 cp (hl)
 jr z,Menu3
 dec a
 cp (hl)
 jr z,Menu2
 jr Menu1       ;now i dont need to subtract a again because if it isn't Menu2, then it has to be Menu1 so jump to it.
Down:
 ld a,4         ;you will have to add or subtract to this number if you have more menus. Take the total number of menu
 ;items you have and subtract one.. that will be the number to make a equal.
 ld hl,Choice
 cp (hl)
 jp z,ProgStart ;by checking if choice is at the maximum i can set limits to how far down the character will go.
 inc (hl)
 jp ProgStart
Up:
 ld a,0         ;this must always be 0, other wise teh arrow will go above the screen.
 ld hl,Choice
 cp (hl)
 jp z,ProgStart
 dec (hl)
 jp ProgStart
Menu5:          ;depending if you have more or less Menus you will have to edit this part
;these parts have what you want to do; which of course can be anything. I would recommend
;putting the last thing in the menu first like i have so that you can use jr instead of jp.
;if you have to add more menu's then put it before Menu5, if you have to subtract items
;then start with Menu5 and subtract to how many items you need...that's commen sense though.
 call _clrScrn
 ld hl,$0000
 ld (_curRow),hl
 ld hl,Text5
 call _puts
 ret
Menu4:
 call _clrScrn
 ld hl,$0000
 ld (_curRow),hl
 ld hl,Text4
 call _puts
 ret
Menu3:
 call _clrScrn
 ld hl,$0000
 ld (_curRow),hl
 ld hl,Text3
 call _puts
 ret
Menu2:
 call _clrScrn
 ld hl,$0000
 ld (_curRow),hl
 ld hl,Text2
 call _puts
 ret
Menu1:
 call _clrScrn
 ld hl,$0000
 ld (_curRow),hl
 ld hl,Text1
 call _puts
 ret

Text1:              ;these 5 items are just the text that is displayed when you choose a 
;particular item in your menu. These are only removable if mess with the labels Menu(1-5)
;and you have to get rid of the text parts up there..so..
 .db "Menu1",0
Text2:
 .db "Menu2",0
Text3:
 .db "Menu3",0
Text4:
 .db "Menu4",0
Text5:
 .db "Menu5",0

Menus:          ;this is another part that you change when you change menu items. To change
;the names of the items just make sure there is 1 space before the name.
 .db " Menu1               ",
 .db " Menu2               ",
 .db " Menu3               ",
 .db " Menu4               ",
 .db " Menu5               ",0
;if you have 8 menu items this is what the last one should look like
;.db " Menu8",0   the reason i get rid of all the spaces is so the calculator doens't scroll
;and get rid of Item one.
Choice:     ;this is the variable that chooses were to put the menu pointer, and also to 
;tell the calculator which item you chose.
 .db $00

.end
;that's it, if you have any comments, suggestions you can email me, ICQ me, or AOL IM me.
;Compaq31@hotmail.com
;ICQ:6741158
;AOL:Compaq31
;if you use this menu and dont plan on putting out the source then dont worry about my name
;or any of that crap. but if you do give out the source then just put on the top of yours,
;menu idea take from Robert. or if your just too lazy to.. i wont hurt you too much......